#include <stdio.h>
int debug = 0;

void main() {
	FILE *in,*out;
	int ds,ns;
	char *s,*p;
	char inputline[100000];
	char outline[100000];
	int accum;
	int nop = 0;
	char last_op=-1;
	int correct=0;
	int i,n;
	in = fopen("math.in","r");
	out = fopen("math.out","r");
	fscanf(in,"%d\n",&ds);
	ns = 0; 
	while (ns++<ds) {
		int error = 0;
		accum = 0;
		error = 0;
		last_op = -1;
		fgets(outline,100000,out);
		fgets(inputline,100000,in);
		if (!strcmp(outline,"NO EXPRESSION\n")) {
			printf("Line %d: NO EXPRESSION answer given.\n",ns);
			error = 1;
			nop ++;
			continue;
		}
		s = outline;
		p = inputline;
		debug&&printf("s: %s\np: %s\n",s,p);
		n = atoi(p);
		for (;isdigit(*p);p++);
		while (isspace(*p)) p++;
		for (s=outline,i=0;i<n;i++) {
                        int j,t;
			debug&&printf("s: %s\np: %s\n",s,p);
			j = atoi(p);
			if (i == 0) accum = j;
			t = atoi(s);
			if (t != j) {
				printf("Line %d: Expected %d, got %d for entry %d\n",ns,j,atoi(s),i+1);
				error = 1;
				break;
			}
			if (last_op!=-1) {
				switch (last_op) {
					case '+':
						accum += t;
						break;
					case '-':
						accum -= t;
						break;
					case '*':
						accum *= t;
						break;
					case '/':
						accum /= t;
						break;
					default:
						printf("Line %d: Unknown operator '%c' after entry %d\n",ns,last_op,i);
						error = 1;
						break;
				}
				if (abs(accum) > 32000) {
					printf("Line %d: Intermediate value out of range (%d) after entry %d\n",ns,accum,i);
					error = 1;
				}
				debug&&printf("Accum now %d\n",accum);
                                //if (error == 1) break;
			}
			for (;isdigit(*p);p++);
			for (;isspace(*p);p++);
			for (;isdigit(*s);s++);
			last_op = *s++;
			debug&&printf("last_op: %c\n",last_op);
		}
                //if (error == 1) continue;
		if (last_op != '=') {
			printf("Line %d: Last operator is not '=' (%c).\n",ns,last_op);
			continue;
		}
		if (accum != atoi(p)) {
			printf("Line %d: Incorrect final value; expected %d, got %d\n",ns,atoi(p),accum);
			continue;
		}
		if (accum != atoi(s)) {
			printf("Line %d: Target value not correctly printed.\n",ns);
			continue;
		}
		for (;isdigit(*s);s++);
		if (*s!='\n') {
			printf("Line %d: Garbage after target value.\n",ns);
			continue;
		}
                if (error==0)
                        correct++;
	}
	printf("%d of %d correct, with %d NO EXPRESSIONs.\n",correct,ds,nop);
}

			
			
	
